package controller;

import config.Config;
import config.subConfig.AxisConfig;
import config.subConfig.DoorConfig;
import config.subConfig.TemplateConfig;
import model.Axis;
import model.Door;
import model.Room;
import model.template.Template;
import utils.TemplateUtils;

import javax.swing.*;
import java.awt.*;
import java.util.List;

/**
 * @author duh
 * @create 2018/7/17 16:01
 * @email duh@elab-plus.com
 **/
public class MyPanel extends JPanel{
    private MyFrame frame;
    private Config config;

    public MyPanel(MyFrame frame, Config config) {
        super();
        this.frame = frame;
        this.config = config;
    }

    @Override
    protected void paintComponent(Graphics g) {
        super.paintComponent(g);
        drawAxis(config,g);
        Room room = new Room(config.getRoom());
        drawRoom(room,g);
//        drawTemplate(room,g);
        drawTemplateAndMove(room,g);
    }

    /**
     * 画坐标系
     * @param config
     * @param g
     */
    private void drawAxis(Config config,Graphics g){
        Axis axis = new Axis();
        AxisConfig axisConfig = config.getAxisPoint();
        //ModuleInAxis已设置坐标轴的偏转
        axis.setX(0);
        axis.setY(0);
        axis.setxLength(axisConfig.getLength());
        axis.setyLength(axisConfig.getWidth());
        axis.setxSpacing(axisConfig.getxSpacing());
        axis.setySpacing(axisConfig.getySpacing());
//        System.out.println("axis3 x="+axis.getX());
        axis.drawSelf(g);
    }
    private void drawTemplate(Room room, Graphics g) {
        List<TemplateConfig> templateList = config.getTemplates();
        TemplateUtils.setRoom(room);
        TemplateUtils.checkYiZhiArray(templateList);
        for(TemplateConfig templateConfig : templateList){
            Template template = new Template(templateConfig);
            TemplateUtils.drawTemplate(template,g);
        }
    }
    private void drawTemplateAndMove(Room room, Graphics g) {
        List<TemplateConfig> templateList = config.getTemplates();
        TemplateUtils.setRoom(room);
        TemplateConfig templateConfig = templateList.get(1);
        Template template = new Template(templateConfig);
        TemplateUtils.drawTemplate(template,g);
        TemplateUtils.routeTemplate(template,1);
        TemplateUtils.drawTemplate(template,g);
    }
    private void drawRoom(Room room, Graphics g){
        room.drawSelf(g);
        DoorConfig doorConfig = config.getDoor();
        Door door = new Door();
        door.setConfig(doorConfig);
        door.setRoom(room);
        door.drawSelf(g);
    }


}
