package model.template;

import config.subConfig.TemplateConfig;
import config.subConfig.TemplateShadowConfig;
import model.ModuleInAxis;

import java.awt.*;
import java.util.List;

/**
 * @author duh
 * @create 2018/7/20 20:12
 * @email duh@elab-plus.com
 **/
public class Template extends ModuleInRoom {
    private int length;
    private int width;
    private List<Integer> alignWall;
    private TemplateShadow shadow;

    public Template(TemplateConfig templateConfig) {
        this.name = templateConfig.getName();
        length = templateConfig.getLength();
        width = templateConfig.getWidth();
        alignWall = templateConfig.getAlignWall();
        x = templateConfig.getX();
        y = templateConfig.getY();
        shadow = new TemplateShadow(this,templateConfig.getShadow());
    }

    public int getLength() {
        return length;
    }

    public void setLength(int length) {
        this.length = length;
    }

    public int getWidth() {
        return width;
    }

    public void setWidth(int width) {
        this.width = width;
    }

    public List<Integer> getAlignWall() {
        return alignWall;
    }

    public void setAlignWall(List<Integer> alignWall) {
        this.alignWall = alignWall;
    }

    public TemplateShadow getShadow() {
        return shadow;
    }

    public void setShadow(TemplateShadow shadow) {
        this.shadow = shadow;
    }
}
